rtrace.
RTRACE(L)                      GRAPHICS               RTRACE(L)


NAME
     rtrace - run a simple RPC ray tracing procedure

SYNOPSIS
     rtrace -o [filename] -i [filename] -b <filename> -B <number>
        -S <number> -d

DESCRIPTION
     Rtrace is a program developed originally to study how ray tracing
     works when distributed to multiple hosts using RPC.  Up to the
     first 10 successful RPC connections as specified in the ~/.rhosts
     file become servers.  NFS is used to share data among client and
     severs.  Options may be in any order, with any omitted to take
     defaults.

     It is capable of depicting a number of balls (up to 1024) and a
     plane that is covered with a tiling of any bitmapped picture.

OPTIONS
     -o Chooses the output data file. If no argument is given, stdout
        is used. If the option is not used the default is data.dis.

     -i Chooses the input (ball) data file. If no argument is given, stdin
        is used. If the option is not used the default is bdata.i.

     -b Chooses the file containing the tiling bitmap. It requires an
        an argument. If the option is not used the default is pat.def.

     -B Chooses contrast of the pattern. 0.0 is no contrast, 1.0 is maximum
        contrast. 1.0 is the default. (useful for fading during animation)

     -s Sets the number of servers to be used from the ~/.rhosts list.
        The default is 8.

     -d If option present (no arguments) servers are not initialized
        with ball and tiling bitmap data.  Handy for compute timing.


PROGRAM NOTES
     This program generates a file in Sun rasterfile(5) format,
     containing a header with x and y sizes, colormap, etc., followed
     by the data in 8-bit greyscale, one pixel to a character, in
     scanline order.  There are two necessary input files: ball data,
     and a pattern bitmap.  The tiling bitmap can be digitized data,
     it must be in the form of an 8-bit deep Sun rasterfile(5), no
     bigger than 1Kx1K.  The ball data is of the following form:

     x y z rad ior refract reflect diffuse ambient

     on each line where x y & z are the coordinates of the center of
     the ball, rad is the radius of the ball, ior is the index of
     refraction for translucent materials (index of refraction for
     glass is about 1.5) the last four numbers determine how much of
     each attribute is used.  Thus a pure silver ball would have 0.0
     1.0 0.0 0.0 as the last numbers, and a pure glass ball would have
     1.0 0.0 0.0 0.0 .

     Viewpoint and the viewing cone are fixed.


FILES
     ./bdata.i  default ball data
     ./pat.def  default floor pattern rasterfile(5)
     ./data.dis default output rasterfile(5)

BUGS
     As with any good software, the complexity of this program hides
     all bugs.
